bindtextdomain("params", "")

class Window(SimpleGladeApp):
    def __init__(self,
                 path=_me.get_path('root') + '/Scripts/Python/GUI/conf/other.glade',
                 root="window1",
                 domain="params", **kwargs):
        SimpleGladeApp.__init__(self, path, root, domain, **kwargs)
        

    def new(self):
        self.measure = _me.get_param('measure')
        _me.insert_funct('refresh_tree', self.refresh_tree)
        _me.insert_funct('verify_tab', self.verify_tab)
        self.updates_commons()
        self.make_viewtree()
        self.update_labels()
    

    
        
    def updates_commons(self):
        # Window title
        txt = "%s : %s" % (_me.string('name_to_read'),
            _me.string('gui_conf_window_title'))
        self.get_widget("window1").set_title(txt)

       
        # Update Frame
        txt = _me.string('gui_conf_update_title')
        self.get_widget("label12").set_text(txt)
        
        txt = "%s : " % _me.string('gui_conf_delay_lb')
        self.get_widget("label13").set_text(txt)
        
        value = _me.get_var('notify_delay')
        self.get_widget("delay_spinbutton").set_value(value)
        
        # Bottom buttons
        txt = _me.string('gui_conf_cancel_bt')
        self.get_widget("label6").set_text(txt)
        
        txt = _me.string('gui_conf_accept_bt')
        self.get_widget("label5").set_text(txt)

        self.get_widget('txt_conf_rate').set_text(str(_me.get_param('Rate')))
        self.get_widget('txt_conf_sample').set_text(str(_me.get_param('Sample')))
        self.get_widget('txtLowThreshold').set_text(str(_me.get_param('low_threshold')))
        self.get_widget('txtHighThreshold').set_text(str(_me.get_param('high_threshold')))
         
        
    ###########################################################
    #
    #   Battery configuration control
    #
    ###########################################################           
    def make_viewtree(self):
        self.index_column = gtk.TreeViewColumn('Index')
        self.index_column.set_min_width(50)
        self.index_cell = gtk.CellRendererText()
        self.index_column.pack_start(self.index_cell, True)
        self.index_column.add_attribute(self.index_cell, 'text', 0)
         
        self.event_column = gtk.TreeViewColumn(_me.string('conf_lblEvent'))
        self.event_column.set_min_width(100)
        self.event_cell = gtk.CellRendererText()
        self.event_column.pack_start(self.event_cell, True)
        self.event_column.add_attribute(self.event_cell, 'text', 1)
        
        self.type_column = gtk.TreeViewColumn(_me.string('conf_lblType'))
        self.type_column.set_min_width(100)
        self.type_cell = gtk.CellRendererText()
        self.type_column.pack_start(self.type_cell, True)
        self.type_column.add_attribute(self.type_cell, 'text', 2)
        
        self.value_column = gtk.TreeViewColumn(_me.string('conf_lblValue'))
        self.value_column.set_min_width(100)
        self.value_cell = gtk.CellRendererText()
        self.value_column.pack_start(self.value_cell, True)
        self.value_column.add_attribute(self.value_cell, 'text', 3)
        
        self.time_column = gtk.TreeViewColumn(_me.string('conf_lblTime'))
        self.time_column.set_min_width(100)
        self.time_cell = gtk.CellRendererText()
        self.time_column.pack_start(self.time_cell, True)
        self.time_column.add_attribute(self.time_cell, 'text', 4)
        
        self.notified_column = gtk.TreeViewColumn(_me.string('conf_lblNotified'))
        self.notified_column.set_min_width(100)
        self.notified_cell = gtk.CellRendererText()
        self.notified_column.pack_start(self.notified_cell, True)
        self.notified_column.add_attribute(self.notified_cell, 'text', 5) 
        
        self.behavior_column = gtk.TreeViewColumn(_me.string('conf_lblBehavior'))
        self.behavior_cell = gtk.CellRendererText()
        self.behavior_column.pack_start(self.behavior_cell, True)
        self.behavior_column.add_attribute(self.behavior_cell, 'text', 6)    
        
        self.value_list = gtk.TreeStore(int, str, str, str, str, str, str)
        self.gadget_viewer = gtk.TreeView(self.value_list)
        self.gadget_viewer.append_column(self.index_column)
        self.gadget_viewer.append_column(self.event_column)
        self.gadget_viewer.append_column(self.type_column)
        self.gadget_viewer.append_column(self.value_column)
        self.gadget_viewer.append_column(self.time_column)
        self.gadget_viewer.append_column(self.notified_column)
        self.gadget_viewer.append_column(self.behavior_column)
        self.get_widget("scrolledwindow1").add(self.gadget_viewer)
        self.get_widget("scrolledwindow1").set_size_request(0, 150)
        self.get_widget("scrolledwindow1").show_all()  
        self.get_widget('cbb_conf_event').set_active(0)
        self.get_widget('txt_conf_value').set_text('1.0')
        self.get_widget('txt_conf_time').set_text('0.1')
        self.get_widget('chkMotors').set_label(_me.string('lblMotors'))
        self.get_widget('chkMotors').set_active(_me.get_param('chkMotors'))
        self.measure.chkMotors = _me.get_param('chkMotors')
        self.gadget_viewer.get_selection().connect("changed",self.on_row_selected)
        #self.gadget_viewer.connect("row_activated", self.on_row_selected)
        self.measure.event_tab = _me.get_param('config')
        self.get_widget('cbb_conf_event').append_text(_me.string('conf_lblChange'))
        self.get_widget('cbb_conf_event').append_text(_me.string('conf_lblThreshold'))
        self.get_widget('cbb_conf_event').set_active(0)
        
	
        for i in range(len(self.measure.event_tab)):
            self.add_row(i)
            
    ###########################################################
    #
    #   Update the labels
    #
    ###########################################################
    def update_labels(self):
        self.get_widget("lbl_conf_event").set_text(_me.string('conf_lblEvent'))
        
        self.get_widget("lbl_conf_type").set_text(_me.string('conf_lblType'))
        self.get_widget("lbl_conf_value").set_text(_me.string('conf_lblValue'))
        self.get_widget("lbl_conf_time").set_text(_me.string('conf_lblTime'))
        self.get_widget("lbl_conf_notified").set_text(_me.string('conf_lblNotified'))
        self.get_widget("lbl_conf_behavior").set_text(_me.string('conf_lblBehavior'))
        self.get_widget("btn_conf_add").set_label(_me.string('conf_btnAdd'))
        self.get_widget("btn_conf_remove").set_label(_me.string('conf_btnRemove'))
        self.get_widget("btn_conf_modify").set_label(_me.string('conf_btnModify'))
        self.get_widget("btnBehavior").set_label(_me.string('conf_btnBehavior'))
        self.get_widget("lbl_conf_sample").set_text(_me.string('conf_lblSample'))
        self.get_widget("lbl_conf_rate").set_text(_me.string('conf_lblRate'))
        self.get_widget("lblControlFrame").set_text(_me.string('conf_lblControl'))
        self.get_widget("lblScript").set_text(_me.string('MainBehavior'))
        self.get_widget("lblHighThreshold").set_label(_me.string('lblHighThreshold'))
        self.get_widget("lblLowThreshold").set_label(_me.string('lblLowThreshold'))


    ###########################################################
    #
    #   On row selected
    #
    ###########################################################
    def on_row_selected(self, obj):
        path = obj.get_selected_rows()
        self.__iter = self.value_list.get_iter(path[1][0])
        index = self.value_list.get_value(self.__iter, 0)
        event =  self.value_list.get_value(self.__iter, 1)
        typet =  self.value_list.get_value(self.__iter, 2)
        value =  self.value_list.get_value(self.__iter, 3)
        time =  self.value_list.get_value(self.__iter, 4)
        notify =  self.value_list.get_value(self.__iter, 5)
        behavior =  self.value_list.get_value(self.__iter, 6)

        if event == _me.string('conf_lblChange'):
            self.get_widget('cbb_conf_event').set_active(0)
            if typet == _me.string('conf_lblDrop'):
                self.get_widget('cbb_conf_type').set_active(0)
            if typet == _me.string('conf_lblRaise'):
                self.get_widget('cbb_conf_type').set_active(1)
            if typet == _me.string('conf_lblChangeD'):
                self.get_widget('cbb_conf_type').set_active(2)
            if typet == _me.string('conf_lblChangeU'):
                self.get_widget('cbb_conf_type').set_active(3)
            self.get_widget('txt_conf_value').set_text(value)
            self.get_widget('txt_conf_time').set_text(time)

        else:
            self.get_widget('cbb_conf_event').set_active(1)
            if typet == _me.string('conf_lblIncrease'):
                self.get_widget('cbb_conf_type').set_active(0)
            if typet == _me.string('conf_lblDecrease'):
                self.get_widget('cbb_conf_type').set_active(1)
            if typet == _me.string('conf_lblBoth'):
                self.get_widget('cbb_conf_type').set_active(2)

            self.get_widget('txt_conf_value').set_text(value)
            self.get_widget('txt_conf_time').set_text('')

        if notify == _me.string('conf_lblNotifiedBehavior'):
            self.get_widget('chk_conf_notified').set_active(True)
        else:
            self.get_widget('chk_conf_notified').set_active(False)

        if behavior != 'N.A.':
            self.get_widget('conf_behavior').set_filename(behavior)
        else:
            self.get_widget('conf_behavior').set_filename('None')
        

    ###########################################################
    #
    #   On row modified
    #
    ###########################################################
    def on_btn_conf_modify_clicked(self, widget, *args):
        index = self.value_list.get_value(self.__iter, 0)
    
        self.measure.event_tab = _me.get_param('config')
        length = len(_me.get_param('config'))
        self.verify_value()
           
        value = []
        value = [index,
                self.get_widget('cbb_conf_event').get_active(),
                self.get_widget('cbb_conf_type').get_active(),
                float(self.get_widget('txt_conf_value').get_text()),
                float(self.get_widget('txt_conf_time').get_text()),
                self.get_widget('chk_conf_notified').get_active(),
                str(self.get_widget('conf_behavior').get_filename()),
                False,
                0]
        self.measure.event_tab = _me.get_param('config')
        
        if self.verify_tab(value):
            self.measure.event_tab[(index-1)] = value
            _me.set_param('config', self.measure.event_tab)
            self.value_list.clear()
            for i in range(len(self.measure.event_tab)):
                self.add_row(i)       

    ###########################################################
    #
    #   On row deleted
    #
    ###########################################################
    def on_btn_conf_remove_clicked(self, widget, *args):
        index = self.value_list.get_value(self.__iter, 0)
        self.measure.event_tab =_me.get_param('config')
        self.measure.event_tab.pop(index - 1)
        _me.set_param('config', self.measure.event_tab)
        self.__iter = 0
        self.value_list.clear()
        for i in range(len(self.measure.event_tab)):
            self.add_row(i)

    ###########################################################
    #
    #   On row added
    #
    ###########################################################
    def on_btn_conf_add_clicked(self, widget, *args):
        length = len(_me.get_param('config'))
        self.verify_value()
        value = []
        value = [(length + 1), 
                self.get_widget('cbb_conf_event').get_active(),
                self.get_widget('cbb_conf_type').get_active(),
                float(self.get_widget('txt_conf_value').get_text()),
                float(self.get_widget('txt_conf_time').get_text()),
                self.get_widget('chk_conf_notified').get_active(),
                str(self.get_widget('conf_behavior').get_filename()),
                False,
                0]
        self.measure.event_tab = _me.get_param('config')
        if self.verify_tab(value):
            self.measure.event_tab.append(value)
            self.refresh_tree()
        
    def refresh_tree(self):
        _me.set_param('config', self.measure.event_tab)
        self.value_list.clear()
        for i in range(len(self.measure.event_tab)):
            self.add_row(i)
            
            
    def verify_tab(self, tab):
        for i in range(len(self.measure.event_tab)):
            if self.measure.event_tab[i][1] == tab[1]:
                if self.measure.event_tab[i][2] == tab[2]:
                    if self.measure.event_tab[i][3] == tab[3]:
                        if self.measure.event_tab[i][4] == tab[4]:
                            if self.measure.event_tab[i][5] == tab[5]:
                                if self.measure.event_tab[i][6] == tab[6]:
                                    return False
        return True

    ###########################################################
    #
    #   Add row function
    #
    ###########################################################
    def add_row(self, tab_index):
        self.measure.event_tab = _me.get_param('config')
        i = tab_index

        if self.measure.event_tab[i][1] == 0:
            Event = _me.string('conf_lblChange')
            if self.measure.event_tab[i][2] == 0:
                Type = _me.string('conf_lblDrop')
            elif self.measure.event_tab[i][2] == 1:
                Type = _me.string('conf_lblRaise')
            elif self.measure.event_tab[i][2] == 2:
                Type = _me.string('conf_lblChangeD')
            elif self.measure.event_tab[i][2] == 3:
                Type = _me.string('conf_lblChangeU')
            Value = str(self.measure.event_tab[i][3])
            Time = str(self.measure.event_tab[i][4])
        else:
            Event = _me.string('conf_lblThreshold')
            if self.measure.event_tab[i][2] == 0:
                Type = _me.string('conf_lblIncrease')
            elif self.measure.event_tab[i][2] == 1:
                Type = _me.string('conf_lblDecrease')
            elif self.measure.event_tab[i][2] == 2:
                Type = _me.string('conf_lblBoth')
            Value = str(self.measure.event_tab[i][3])
            Time = 'N.A.'
                
        if self.measure.event_tab[i][5]:
            Notify = _me.string('conf_lblNotifiedBehavior')
            if self.measure.event_tab[i][6] ==None:
                Behavior = _me.string('conf_lblDefaultBehavior')
            else:
                Behavior = str(self.measure.event_tab[i][6])
        else:
            Notify = _me.string('conf_lblNotNotified')
            Behavior = 'N.A.'
                
        self.value_list.append(None,[(i+1), Event, Type, Value, Time, Notify, Behavior])
        
    ###########################################################
    #
    #   On combo box event
    #
    ###########################################################        
    def on_cbb_conf_event_changed(self, widget, *args):
        if self.get_widget('cbb_conf_event').get_active() == 0:
            for i in range (4):
                self.get_widget('cbb_conf_type').remove_text(0)
            self.get_widget('cbb_conf_type').append_text(_me.string('conf_lblDrop'))
            self.get_widget('cbb_conf_type').append_text(_me.string('conf_lblRaise'))
            self.get_widget('cbb_conf_type').append_text(_me.string('conf_lblChangeD')) 
            self.get_widget('cbb_conf_type').append_text(_me.string('conf_lblChangeU'))           
            self.get_widget('cbb_conf_type').set_active(0)
        else:
            for i in range (4):
                self.get_widget('cbb_conf_type').remove_text(0)
            self.get_widget('cbb_conf_type').append_text(_me.string('conf_lblIncrease'))
            self.get_widget('cbb_conf_type').append_text(_me.string('conf_lblDecrease'))
            self.get_widget('cbb_conf_type').append_text(_me.string('conf_lblBoth'))
            self.get_widget('cbb_conf_type').set_active(0)
      
      
    ###########################################################
    #
    #   On accept button clicked
    #
    ###########################################################             
    def on_accept_clicked(self, widget, *args):
        _me.set_param('Rate', float(self.get_widget('txt_conf_rate').get_text()))
        _me.set_param('Sample',float(self.get_widget('txt_conf_sample').get_text()))
        _me.set_param(('MainScript'), str(self.get_widget('mainScript').get_filename()))
        _me.set_param(('chkMotors'), self.get_widget('chkMotors').get_active())
        self.measure.chkMotors = self.get_widget('chkMotors').get_active()
        self.measure.rate_backup = _me.get_param('Rate')
        self.measure.sample_backup = _me.get_param('Sample')
        
        try: 
            float(self.get_widget('txtLowThreshold').get_text())
        except:
            self.get_widget('txtLowThreshold').set_text('4.8')
        
        if float(self.get_widget('txtLowThreshold').get_text()) < 4.0:
            self.get_widget('txtLowThreshold').set_text('4.0')
        if float(self.get_widget('txtLowThreshold').get_text()) > 6.3:
            self.get_widget('txtLowThreshold').set_text('6.3')
        self.measure.low_threshold = float(self.get_widget('txtLowThreshold').get_text())
        _me.set_param('low_threshold', self.measure.low_threshold)
        
        try: 
            float(self.get_widget('txtHighThreshold').get_text())
        except:
            self.get_widget('txtHighThreshold').set_text('4.8')
        
        if float(self.get_widget('txtHighThreshold').get_text()) < self.measure.low_threshold:
            self.get_widget('txtHighThreshold').set_text(str(self.measure.low_threshold + 0.1))
        if float(self.get_widget('txtHighThreshold').get_text()) > 6.4:
            self.get_widget('txtHighThreshold').set_text('6.4') 
               
        self.measure.high_threshold = float(self.get_widget('txtHighThreshold').get_text())
        _me.set_param('high_threshold', self.measure.high_threshold)    

        self.measure.absolute_threshold_high_flag = False
        self.measure.absolute_threshold_low_flag = False
        

        
        _me.set_var('notify_delay', int(self.get_widget("delay_spinbutton").get_value()))

        self.get_widget("window1").destroy()
     
     
    ###########################################################
    #
    #   On cancel button clicked
    #
    ###########################################################   
    def on_cancel_clicked(self, widget, *args):
        self.get_widget("window1").destroy()
        
    ###########################################################
    #
    #   On Clear path button clicked
    #
    ###########################################################   
    def on_btnBehavior_clicked(self, widget, *args):
        self.get_widget('conf_behavior').set_filename('None')
        index = self.value_list.get_value(self.__iter, 0)
        self.measure.event_tab[index-1][6] = None
        
        self.value_list.clear()
        for i in range(len(self.measure.event_tab)):
            self.add_row(i)
        
    ###########################################################
    #
    #   Verify the value
    #
    ###########################################################
    def verify_value(self):
        if self.get_widget('cbb_conf_event').get_active() == 0:
            maximum = 2.5
            minimum = 0.025
        else:
            maximum = 6.5
            minimum = 4.0
        try: 
            float(self.get_widget('txt_conf_time').get_text())
        except:
            self.get_widget('txt_conf_time').set_text('0.1')
        
        if float(self.get_widget('txt_conf_time').get_text()) < self.measure.rate:
            self.get_widget('txt_conf_time').set_text(str(self.measure.rate))
        if float(self.get_widget('txt_conf_time').get_text()) > self.measure.rate * self.measure.sample:
            self.get_widget('txt_conf_time').set_text(str(self.measure.rate * self.measure.sample))

        try: 
            float(self.get_widget('txt_conf_value').get_text())
        except:
            self.get_widget('txt_conf_value').set_text(str(minimum))
        
        if float(self.get_widget('txt_conf_value').get_text()) < minimum:
            self.get_widget('txt_conf_value').set_text(str(minimum))
        if float(self.get_widget('txt_conf_value').get_text()) > maximum:
            self.get_widget('txt_conf_value').set_text(str(maximum))

