bindtextdomain("params", "")
sys.path.append(_me.get_path('root') + '/Scripts/Python')
from Battery_class import Graph

class Window(SimpleGladeApp):

    def __init__(self,
                 path=_me.get_path('root') + '/Scripts/Python/GUI/widget/other.glade',
                 root="window1",
                 domain="params", **kwargs):
        SimpleGladeApp.__init__(self, path, root, domain, **kwargs)
        
    ###########################################################
    #
    #   Display the new window
    #
    ###########################################################
    def new(self):
        self.get_widget("window1").set_title(_me.string('name_to_read'))
        self.get_widget("lblThreshold").set_text(_me.string('widget_lblTest'))

        self.get_widget("btnAdd").set_label(_me.string('widget_lblSet'))
        
        self.get_widget('txtValue').set_text('1.0')
        self.get_widget('txtTime').set_text('0.1')

        self.get_widget('cbbEvent').append_text(_me.string('conf_lblChange'))
        self.get_widget('cbbEvent').append_text(_me.string('conf_lblThreshold'))
        self.get_widget('cbbEvent').set_active(0)
        
        self.get_widget("lblEvent").set_text(_me.string('conf_lblEvent'))
        self.get_widget("lblType").set_text(_me.string('conf_lblType'))
        self.get_widget("lblValue").set_text(_me.string('conf_lblValue'))
        self.get_widget("lblTime").set_text(_me.string('conf_lblTime'))
        self.get_widget("lblNotify").set_text(_me.string('conf_lblNotified'))
        self.get_widget("lblScript").set_text(_me.string('conf_lblBehavior'))
        self.get_widget("lblBtnApply").set_text(_me.string('widget_lblBtnApply'))

        tab = _me.get_param('test_tab')
        self.get_widget('cbbEvent').set_active(tab[0][1])
        self.get_widget('cbbType').set_active(tab[0][2])
        self.get_widget('txtValue').set_text(str(tab[0][3]))
        self.get_widget('txtTime').set_text(str(tab[0][4]))
        self.get_widget('chkNotify').set_active(tab[0][5])
        if tab[0][6] != None:
            self.get_widget('Behavior').set_filename(str(tab[0][6]))

        
        
        thread.start_new_thread(self.update, ())
        
    ###########################################################
    #
    #   Update the values
    #
    ###########################################################        
    def update_value(self):

        self.measure.changetext = _me.string('conf_lblChange')
        self.measure.thresholdtext = _me.string('conf_lblThreshold')
        try:
            self.graph.battery = _me.string('battery')
            self.graph.plugged = _me.string('plugged')
            self.graph.charging = _me.string('charging')
        except:
            print sys.exc_info()

    ###########################################################
    #
    #   Event functions
    #
    ########################################################### 
    def on_window1_destroy(self, widget, *args):
        _me.get_param('measure').GUI_on = False
        self.measure.GUI_on = False

    def on_btnAdd_clicked(self, widget, *args):
        length = len(_me.get_param('config'))
        self.verify_value()
        value = []
        value = [(length + 1), 
                self.get_widget('cbbEvent').get_active(),
                self.get_widget('cbbType').get_active(),
                float(self.get_widget('txtValue').get_text()),
                float(self.get_widget('txtTime').get_text()),
                self.get_widget('chkNotify').get_active(),
                str(self.get_widget('Behavior').get_filename()),
                False,
                0]
        self.measure.event_tab = _me.get_param('config')
        verify_tab = _me.get_funct('verify_tab')
        if verify_tab(value):
            self.measure.event_tab.append(value)
            refresh_tree = _me.get_funct('refresh_tree')
            refresh_tree()

    def on_btnApply_clicked(self, widget, *args):
        length = len(_me.get_param('config'))
        self.verify_value()
        value = []
        value = [(length + 1), 
                self.get_widget('cbbEvent').get_active(),
                self.get_widget('cbbType').get_active(),
                float(self.get_widget('txtValue').get_text()),
                float(self.get_widget('txtTime').get_text()),
                self.get_widget('chkNotify').get_active(),
                str(self.get_widget('Behavior').get_filename()),
                False,
                0]
        self.measure.test_tab[0] = value
        _me.set_param('test_tab', self.measure.test_tab)
        
 
        
    def on_expander_activate(self, widget, *args):
        self.get_widget('txtValue').set_text(str(self.measure.test_tab[0][3]))
        self.get_widget('txtTime').set_text(str(self.measure.test_tab[0][4]))

    ###########################################################
    #
    #   On combo box event
    #
    ###########################################################        
    def on_cbb_conf_event_changed(self, widget, *args):
        if self.get_widget('cbbEvent').get_active() == 0:
            for i in range (4):
                self.get_widget('cbbType').remove_text(0)
            self.get_widget('cbbType').append_text(_me.string('conf_lblDrop'))
            self.get_widget('cbbType').append_text(_me.string('conf_lblRaise'))
            self.get_widget('cbbType').append_text(_me.string('conf_lblChangeD')) 
            self.get_widget('cbbType').append_text(_me.string('conf_lblChangeU'))           
            self.get_widget('cbbType').set_active(0)
        else:
            for i in range (4):
                self.get_widget('cbbType').remove_text(0)
            self.get_widget('cbbType').append_text(_me.string('conf_lblIncrease'))
            self.get_widget('cbbType').append_text(_me.string('conf_lblDecrease'))
            self.get_widget('cbbType').append_text(_me.string('conf_lblBoth'))
            self.get_widget('cbbType').set_active(0)
            
    
    ###########################################################
    #
    #   Value integrity control
    #
    ########################################################### 
    def check_float_value(self, value, minimum, maximum):
        try:
            value = float(value)
        except:
            value = float(minimum)
            
        if value < float(minimum):
            value = float(minimum)
        elif value > float(maximum):
            value = float(maximum)   
        return value


            
    def update(self):
        self.graph = Graph()
        _me.set_param('graph', self.graph)
        #_me.update_informations()
        self.measure = _me.get_param('measure')
        _me.get_param('measure').graph_measure = self.graph
        _me.get_param('graph').measure_graph = self.measure
        _me.get_param('measure').GUI_on = True
        self.update_value()
        self.graph.set_size_request(400, 200)
        gtk.gdk.threads_enter()
        layout = self.get_widget('vbox2')
        layout.add(self.graph)
        layout.show_all()
        gtk.gdk.threads_leave()


    def verify_value(self):
        if self.get_widget('cbbEvent').get_active() == 0:
            maximum = 2.5
            minimum = 0.025
        else:
            maximum = 6.5
            minimum = 4.0
    
        try: 
            float(self.get_widget('txtTime').get_text())
        except:
            self.get_widget('txtTime').set_text('1.0')
        
        if float(self.get_widget('txtTime').get_text()) < self.measure.rate:
            self.get_widget('txtTime').set_text(str(self.measure.rate))
        if float(self.get_widget('txtTime').get_text()) > self.measure.rate * self.measure.sample:
            self.get_widget('txtTime').set_text(str(self.measure.rate * self.measure.sample))

        try: 
            float(self.get_widget('txtValue').get_text())
        except:
            self.get_widget('txtValue').set_text(str(minimum))
        
        if float(self.get_widget('txtValue').get_text()) < minimum:
            self.get_widget('txtValue').set_text(str(minimum))
        if float(self.get_widget('txtValue').get_text()) > maximum:
            self.get_widget('txtValue').set_text(str(maximum))


